/* vi: set sw=4 ts=4: */
/*
 * KON2 - Kanji ON Console -
 * Copyright (C) 1993 by MAEDA Atusi (mad@math.keio.ac.jp)
 *
 * CCE - Console Chinese Environment -
 * Copyright (C) 1998-2003 Rui He (rhe@3eti.com)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY MAEDA ATUSI ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE TERRENCE R. LAMBERT BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * 
 */

#include	<stdio.h>
#include	<errno.h>
#include	<stdarg.h>
#include	<stdlib.h>
#include	<string.h>
#include	<sys/types.h>

#include	<defs.h>
#include	<errors.h>
#include	<vc.h>

#define MAX_MSGLEN 1024

static void CCEPrintf(const char *head, const char *format, va_list args)
{

#if 0
        FILE *fp = fopen("/tmp/CCE-log","a");
        fprintf(fp, "%s", head);
        vfprintf(fp, format, args);
        fclose(fp);
#endif

    {
		fprintf(stderr, "%s", head);
		vfprintf(stderr, format, args);
	} 
#if 0 /* Rui He Aug 9, 2003 don't output in Terminal!! */
    else 
    {
		VtWrite(curCon,head, strlen(head));

		vsnprintf(buf, MAX_MSGLEN, format, args);
		VtWrite(curCon,buf, strlen(buf));
	}
#endif
}

void fatal(const char *format, ...)
{
	va_list args;

	va_start(args, format);
	fprintf(stderr, "CCE> Fatal error: ");
	vfprintf(stderr, format, args);
	va_end(args);
	exit(EXIT_FAILURE);
}

void warn(const char *format, ...)
{
	va_list args;

	va_start(args, format);
	CCEPrintf("CCE> Warning: ", format, args);
	va_end(args);
}

void error(const char *format, ...)
{
	va_list args;

	va_start(args, format);
	CCEPrintf("CCE> Error: ", format, args);
	va_end(args);
}

void message(const char *format, ...)
{
	va_list args;

	va_start(args, format);
	CCEPrintf("CCE> ", format, args);
	va_end(args);
}

void Perror(const char *msg)
{
	message("Error - %s: %s\r\n", msg, strerror(errno));
}

void PerrorExit(const char *message)
{
	fprintf(stderr, "%s: %s\r\n", message, strerror(errno));
	exit(EXIT_FAILURE);
}

